﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ThinkGeo.MapSuite.DesktopEdition;
using ThinkGeo.MapSuite.Core;

namespace Post8958Sample
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            PresetTrackInterativeOverlay presetInterativeOverlay = new PresetTrackInterativeOverlay();
            presetInterativeOverlay.PresetPointShape = new PointShape(112, 37);

            winformsMap1.MapUnit = GeographyUnit.DecimalDegree;

            winformsMap1.TrackOverlay = presetInterativeOverlay;
            winformsMap1.TrackOverlay.TrackMode = TrackMode.Polygon;

            winformsMap1.CurrentExtent = new RectangleShape(0, 90, 90, 0);
        }
    }

    public class PresetTrackInterativeOverlay : TrackInteractiveOverlay
    {
        private PointShape presetPointShape = null;
        public PointShape PresetPointShape
        {
            get { return presetPointShape; }
            set { presetPointShape = value; }
        }
        protected override BaseShape GetTrackingShapeCore()
        {
            BaseShape baseShape = base.GetTrackingShapeCore();

            if (baseShape is PolygonShape)
            {
                PolygonShape polygon = (PolygonShape)baseShape;
                if (polygon != null && presetPointShape != null)
                {
                    Vertices[0] = new Vertex(presetPointShape);
                }
            }

            return baseShape;
        }
    }

}
